//-----------------------------------------------------------------------
// class IGhostMaster
//
//
// Author:  Sylvain Lefebvre
// History: Created 04/04/2002
//-----------------------------------------------------------------------
#ifndef __IGHOSTMASTER__
#define __IGHOSTMASTER__
//-----------------------------------------------------------------------
#include "INetworkObject.h"
#include "INetworkGame.h"
//-----------------------------------------------------------------------
class IGhostMaster : public virtual INetworkObject
{
private:

  INetworkGame *m_Ng;

protected:
  
  int  m_iGhostMasterId;
  int  m_iGhostMasterType;
  int  m_iUpdateMode;
  bool m_bNeedUpdate;
  
public:

  IGhostMaster();
  virtual ~IGhostMaster();
  
  bool needUpdate()            {return (m_bNeedUpdate);}
  void setNeedUpdate(bool b)   {m_bNeedUpdate=b;}

  virtual const unsigned char *getGhostMasterData()     {return (writeNetworkData());}
  virtual int                  getGhostMasterDataSize() {return (networkDataSize());}

  virtual const unsigned char *getGhostMasterInitData()     {return (writeNetworkData());}
  virtual int                  getGhostMasterInitDataSize() {return (networkDataSize());}


  virtual void messageFromGhost(int,const ng_ghost_msg *,
				const unsigned char *,int) {}

  void         sendMessageToGhost(int,int,const unsigned char *,int);
  void         sendMessageToGhosts(int,const unsigned char *,int);

  void setGhostMasterId(int i) {m_iGhostMasterId=i;}
  int  getGhostMasterId()      {return (m_iGhostMasterId);}
  int  getGhostMasterType()    {return (m_iGhostMasterType);}
  int  getUpdateMode()         {return (m_iUpdateMode);}

  void setNetworkGame(INetworkGame *ng);

  bool isMaster() {return (m_iGhostMasterId >= 0);}
};
//-----------------------------------------------------------------------
#endif
//-----------------------------------------------------------------------
// ---------------------------------------------------------- 
// Sylvain Lefebvre - (c) 2002 - Sylvain.Lefebvre@laposte.net
// ----------------------------------------------------------
