#ifndef INC_CalcWalker_hpp_
#define INC_CalcWalker_hpp_

#line 2 "calc.g"

#include <cmath>
#include <map>
#include <string>
class CMobile;
#include "atr_nfo.h"

#line 13 "CalcWalker.hpp"
#include <antlr/config.hpp>
#include "CalcWalkerTokenTypes.hpp"
/* $ANTLR 2.7.3rc2: "calc.g" -> "CalcWalker.hpp"$ */
#include <antlr/TreeParser.hpp>

class CUSTOM_API CalcWalker : public ANTLR_USE_NAMESPACE(antlr)TreeParser, public CalcWalkerTokenTypes
{
#line 440 "calc.g"

private:
    int field;
    CMobile *m_Mobile, *m_Collider;
    int m_Mobile_id,m_Mobile_client_id;
    CVertex m_Choc;
    typedef std::map<string, double> fltMap_t;
    fltMap_t mFloats;
    typedef std::map<string, mob_adress> mobMap_t;
    mobMap_t mMobiles;

    class snapshot
    {
        public:
        fltMap_t mFloats;
        mobMap_t mMobiles;
        mobile_data mMobileData;
        public:
        snapshot() : mFloats(), mMobiles() {}
    };
    list<snapshot> mMemory;

public:
    void bindTo(CMobile *m, int fld, CMobile *collider=NULL, CVertex choc = CVertex(0.0, 0.0, 0.0))
    {
      m_Mobile=m; 
      m_Mobile_id = WORLD.getMobileLocalId(m)-1;
      m_Mobile_client_id = NETWORK.clientId();
      cur_line = 0;
      cur_mob = m_Mobile_id+1;
      field = fld;
      m_Collider = collider;
      mFloats.clear();
      mMobiles.clear();
      mMemory.clear();
      m_Choc = choc;
    }
    double get_atr_nfo(int, mob_adress, int);
    void set_atr_nfo(atr_nfo&, int, int, string, int);
    CMobile *getMobilePtr(mob_adress, int mode=0);
    bool areMobilesEqual(mob_adress mob, mob_adress mob2);
    bool isMobileEqualN(mob_adress mob, double f);
    double *getFloatRef(string, int mode=0);
    mob_adress *getMobileRef(string, int mode=0);
    double *getFloatWriteRefCheck(string, int mode=0);
    mob_adress *getMobileWriteRefCheck(string, int mode=0);
    void setAttributes(atr_nfo& atr, double a);
#line 22 "CalcWalker.hpp"
public:
	CalcWalker();
	void initializeASTFactory( ANTLR_USE_NAMESPACE(antlr)ASTFactory& factory );
	int getNumTokens() const
	{
		return CalcWalker::NUM_TOKENS;
	}
	const char* getTokenName( int type ) const
	{
		if( type > getNumTokens() ) return 0;
		return CalcWalker::tokenNames[type];
	}
	const char* const* getTokenNames() const
	{
		return CalcWalker::tokenNames;
	}
	public: void start(ANTLR_USE_NAMESPACE(antlr)RefAST _t);
	public: void expr_(ANTLR_USE_NAMESPACE(antlr)RefAST _t);
	public: void expr(ANTLR_USE_NAMESPACE(antlr)RefAST _t);
	public: double  fexpr(ANTLR_USE_NAMESPACE(antlr)RefAST _t);
	public: mob_adress  ref(ANTLR_USE_NAMESPACE(antlr)RefAST _t);
	public: atr_nfo  attribref(ANTLR_USE_NAMESPACE(antlr)RefAST _t);
public:
	ANTLR_USE_NAMESPACE(antlr)RefAST getAST()
	{
		return returnAST;
	}
	
protected:
	ANTLR_USE_NAMESPACE(antlr)RefAST returnAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST _retTree;
private:
	static const char* tokenNames[];
#ifndef NO_STATIC_CONSTS
	static const int NUM_TOKENS = 129;
#else
	enum {
		NUM_TOKENS = 129
	};
#endif
	
	static const unsigned long _tokenSet_0_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_0;
};

#endif /*INC_CalcWalker_hpp_*/
